package org.lx.demo;

import java.io.*;
import java.util.*;

import java.awt.event.*;

import org.lx.gui.dui.*;
import org.lx.gui.dui.com.*;
import org.lx.util.*;
import org.lx.xml.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author UILOGIC
 * @version 1.0
 */

public class duilBrowser
{
  public static class ViewActionHandler extends AbstractDUIListener implements
      ActionListener
  {

    public void actionPerformed(ActionEvent e)
    {
      AbstractCom root = getComponent().getRoot();
      AbstractCom dlg_chooser = root.findChildRecursively("name", "dialogs");
      if (dlg_chooser != null)
      {
        Object selected = dlg_chooser.getComAttribute("selectedItem");
        if (selected instanceof ItemWrapper)
        {
          XMLElementModel model = (XMLElementModel) ( (ItemWrapper) selected).
              getContext();
          if (model instanceof DUIModel)
          {
            model = (XMLElementModel) ( (DUIModel) model).getUserData();
          }
          ComFactory.getSingleInstance().showDialog(model, null, null, true);
        }
      }
    }
  }

  public static class FileRender implements AbstractCom.ValueRender
  {
    public Object getValue(AbstractCom com, Object key)
    {
      Object[] retval = null;
      //provide value for dialog chooser.
      do
      {
        if ("opend_file".equals(key) == false)
        {
          break;
        }
        if (com instanceof ComFileChooserButton == false)
        {
          break;
        }
        ComFileChooserButton btn = (ComFileChooserButton) com;
        File[] select_files = (File[]) btn.getComAttribute("files");
        if (select_files == null || select_files.length == 0)
        {
          break;
        }

        try
        {
          FileReader reader = new FileReader(select_files[0]);
          XMLParser parser = new XMLParser();
          XMLElementModel root = parser.parser(reader);
          if (root == null || root.getChilds().size() == 0)
          {
            break;
          }
          ArrayList coms = new ArrayList();
          Iterator it = root.getChilds().iterator();
          XMLElementModel model = null;
          DUIModel dm = null;

          while (it.hasNext())
          {
            model = (XMLElementModel) it.next();
            dm = new DUIModel();
            dm.setUserData(model);
            dm.setText(model.getAttribute("id"));
            coms.add(dm);
          }
          retval = coms.toArray();
        } catch (FileNotFoundException e)
        {
          Log.log(Log.WARNING, null, e);
        }

      } while (false);
      return retval;
    }

  }

  public static PipedWriter m_writer;
  public static PipedReader m_reader;

  public static void main(String[] argv)
  {
    ComFactory.createInstance();
    ComFactory factroy = ComFactory.getSingleInstance();
    CompositeRenders renders = new CompositeRenders();
    AbstractCom.IORender ioRender = new DefaultIORender();
    DefaultListenerRender listenerRender = new DefaultListenerRender();
    listenerRender.addListener("viewAction", new ViewActionHandler());
    renders.setValueRender(new AbstractCom.DefaultValueRender());
    renders.setIORender(ioRender);
    renders.setListenerRender(listenerRender);
    renders.setValueRender(new FileRender());

    Reader reader =
        new InputStreamReader(
        duilBrowser.class.getResourceAsStream(
        "/org/lx/demo/duilBrowser.xml"));

    factroy.showDialog(reader, "id", "duilBrowser", renders, null, true);
    System.exit(0);
  }
}
